import { LRParser } from '@lezer/lr';
import { completeFromList } from '@codemirror/autocomplete';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_Ident = {__proto__:null,funk:12, Zahl:150, "Fließkommazahl":152, Wahrheitswert:154, Zeichen:156, Zeichenkette:158, Nichts:160, Liste:162, von:20, ergibt:26, "überweise":36, falls:44, sonst:46, ja:54, nein:56, exit:74, als:94, abbrechen:102, weitermachen:106, setze:110, auf:112, "ändere":116, solange:120, beantrage:128};
const parser = LRParser.deserialize({
  version: 14,
  states: "0OQ]QPOOOOQO'#Dx'#DxOOQO'#Dq'#DqQ]QPOOOhQPO'#DdO!PQPO'#C`O!UQPO'#DmOOQO-E7o-E7oOOQO'#Ce'#CeO!ZQPO'#CeO!`QPO,5:OO!eQPO,58zOOQO'#Do'#DoO!jQPO,5:XOhQPO,59PO!oQPO1G/jO!tQPO'#CcO!{QPO1G.fO#TQPO1G/sOOQO1G.k1G.kO#YQPO7+%UOOQO,58},58}O$QQPO,58}O$VQPO'#CjOOQO7+$Q7+$QOhQPO7+$QOOQO'#Dp'#DpO$pQPO7+%_OOQO'#Cp'#CpOOQO'#Cv'#CvO$uQPO'#CzOOQO'#DQ'#DQOOQO'#DP'#DPO$|QPO'#DPO#YQPO'#DSO%qQPO<<HpO%|QPO'#CtO#YQPO'#D^OOQO'#Ct'#CtOOQO'#Co'#CoO#YQPO'#CqO&nQPO1G.iO&vQPO,59UO'RQPO'#CoO(iQPO'#CoOOQO'#Cl'#ClOOQO'#Ds'#DsO(wQPO,59UOOQO,59U,59UO)bQPO'#CmO)iQPO'#D`O)nQPO'#DbO)sQPO'#DgO#YQPO'#DiO#OQPO<<GlOOQO<<Hy<<HyOOQO,59f,59fO)xQPO,59fO#YQPO,59rOOQO,59n,59nO#YQPO,59pOhQPO,59vOOQOAN>[AN>[O*ZQPO,59tO*bQPO,59xO*mQPO,59]OhQPO'#DrO*xQPO7+$TOOQO7+$T7+$TOOQO1G.p1G.pOOQO,5:V,5:VO+QQPO1G.pOOQO-E7q-E7qO+]QPO,59XOOQO,59X,59XOOQO,59z,59zOOQO,59|,59|O+hQPO,5:RO*mQPO,5:TOOQOAN=WAN=WO#YQPO'#DtO+mQPO1G/QOOQO1G/Q1G/QO+sQPO1G/QO+xQPO1G/^OOQO1G/[1G/[OOQO1G/b1G/bO,gQPO'#DZOOQO1G/`1G/`O,xQPO1G/`OOQO1G/d1G/dO,}QPO1G.wO.tQPO,5:^OOQO-E7p-E7pOOQO<<Go<<GoOOQO7+$[7+$[P*RQPO'#DUOOQO1G.s1G.sO#YQPO1G/mO.yQPO1G/oO0ZQPO,5:`OOQO-E7r-E7rOOQO7+$l7+$lO0oQPO7+$lO0tQPO,59uOOQO,59u,59uOOQO7+$z7+$zO1PQPO7+$cOOQO1G/x1G/xO1XQPO7+%XOOQO7+%Z7+%ZOOQO<<HW<<HWOOQO1G/a1G/aOOQO<<G}<<G}OOQO<<Hs<<Hs",
  stateData: "1k~O!kOSPOSQOS~OUTO!XSO!bUO~O!mWO!nWO!oWO!pWO!qWO!rWO!sXO~OTZO~OT[O~OY^O~OT_O~OW`O~OYbO~O!YdO~O[eO~PhO]iO_gO~OTjO~OTqOWuO_gOfxOivOkmOlmOmvOonOrvOuoOwrO~OTyO~Ob!RO!T!SO!V!TO!XSO![!UO!^!VO!`!QO~P#YO!R!XO~Oq!YO~P#YO{![OWsXysX!PsX!RsX!`sXZsXpsXqsX[sX_sX~Oy!^O!P!_O!R!`O~OW!aOyhX!PhX!RhX!`hXZhXphXqhX[hX_hX~OZ!dO[!fO~Oy!^O!P!_O!`!gO~O!R!hOT!_XW!_X_!_Xb!_Xf!_Xi!_Xk!_Xl!_Xm!_Xo!_Xr!_Xu!_Xw!_XycX!PcX!T!_X!V!_X!X!_X![!_X!^!_X!`!_X~O!R!hOycX!PcX!`cX~Ob!RO!T!SO!V!TO!XSO![!UO!^!VO!`!gO~P#YO!R!lO~P#YO!R!mO~O!R!nO~OT!oO~OZ!rOp!uOq!tOy!^O!P!_O~O[!zO~P#YO[!|Oy!^O!P!_O~O_gOy!^O!P!_O~OZ!dO[#QO~Oy!^O!P!_O!`#RO~Oy!^O!P!_O!R#TO~O!Y#UO~OZ!rOp#ZOq#YO~Oy!^O!Pzi!Rzi!`ziZzipziqzi[zi_zi~OZ!rOp#]Oy!^O!P!_O[}X~O[#^O~Og#_Oyei!Pei!ReiTeiWei_eibeifeiieikeileimeioeireiueiwei!Tei!Vei!Xei![ei!^ei!`eiZeipeiqei[ei~OT#`O~O!R#bOT!]iW!]i_!]ib!]if!]ii!]ik!]il!]im!]io!]ir!]iu!]iw!]i!T!]i!V!]i!X!]i![!]i!^!]i!`!]i~Oy!^O!P!_OZ!hap!haq!ha[!ha~Oq#cO~OZ!rOp#dO[}a~O_gOfxO~Oy!^O!P!_O!R#fO~OPZ{wy{~",
  goto: "([!mPPPP!nPP!rP!uPPPP#XP#x#|P$Q$|%`PP%sP&VPPP&VPPPP&g&wP&VP&VP&VP&V'X&VP&VP#|P#|P'[PP#|P#|P#|P!nP'd'g'j'p'v'|PPP(WTPORRaZQYSQc^Qf`Q!WiQ!x!_R#O!dQhalldgnrux!P!R!V![!^!a!r#UQ!q!WQ!}!cQ#V!pR#e#_T!Og!PT}g!PQsdQzgQ!ZnQ!]rQ!buQ!cxQ!i!PQ!k!RQ!p!VQ!v![Q!w!^Q!y!aQ#W!rR#a#Uhwdnrux!R!V![!^!a!r#UT{g!Plldgnrux!P!R!V![!^!a!r#UR#e#_hwdnrux!R!V![!^!a!r#UT|g!Pmvdgnrux!P!R!V![!^!a!r#Umtdgnrux!P!R!V![!^!a!r#Umpdgnrux!P!R!V![!^!a!r#UR!{!aSPORT}g!PR]URkbQRORVRQ!eyR#P!eQ!PgR!j!PQ!s!ZS#X!s#[R#[!yTQOR",
  nodeNames: "⚠ LineComment BlockComment Program FunctionDefinition Ident funk Parameters ( Type von SlashDelimeter ) ergibt Block { Statement UeberweiseStmt überweise Expression ExprWithBlock IfExpr falls sonst ExprWithoutBlock Number Bool Bool Bool Char List [ , ] String VariableName BuiltinFunc BuiltinFunc PrefixExpr PrefixOp InfixExpr InfixOp AssignExpr AssignOp CallExpr ArgumentList CastExpr als NestedExpr ; AbbrechenStmt abbrechen WeitermachenStmt weitermachen SetzeStmt setze auf AendereStmt ändere SolangeStmt solange ExprStmt } BeantrageStmt beantrage BeantrageFn BeantrageModule",
  maxTerm: 81,
  skippedNodes: [0,1,2],
  repeatNodeCount: 4,
  tokenData: "/u~RtXY#cYZ#c]^#cpq#cqr#hrs#uuv%gvw%twx&Pxy'qyz'vz{'{{|%g|}(W}!O(]!P!Q(g!Q!R*e!R![+_![!]#p!]!^-r!^!_-w!_!`.S!`!a.[!c!}.g!}#O/U#P#Q/Z#Q#R%g#R#S.g#T#o.g#o#p/`#p#q/e#q#r/p%w%x.g%|%}.g&`&a.g&f&g.g~#hO!k~~#mPw~!_!`#p~#uOy~~#zVr~Or#urs$as#O#u#O#P$f#P;'S#u;'S;=`%a<%lO#u~$fOr~~$iRO;'S#u;'S;=`$r;=`O#u~$wWr~Or#urs$as#O#u#O#P$f#P;'S#u;'S;=`%a;=`<%l#u<%lO#u~%dP;=`<%l#u~%lPy~!_!`%o~%tO{~~%yQy~vw#p!_!`%o~&UVm~Ow&Pwx&kx#O&P#O#P&p#P;'S&P;'S;=`'k<%lO&P~&pOm~~&sRO;'S&P;'S;=`&|;=`O&P~'RWm~Ow&Pwx&kx#O&P#O#P&p#P;'S&P;'S;=`'k;=`<%l&P<%lO&P~'nP;=`<%l&P~'vOW~~'{O[~~(QQy~z{%g!_!`%o~(]Op~~(dPw~y~!_!`%o~(lRZ~z{(u!P!Q)|!_!`%o~(xTOz(uz{)X{;'S(u;'S;=`)v<%lO(u~)[VOz(uz{)X{!P(u!P!Q)q!Q;'S(u;'S;=`)v<%lO(u~)vOQ~~)yP;=`<%l(u~*RSP~OY)|Z;'S)|;'S;=`*_<%lO)|~*bP;=`<%l)|~*jTi~|}*y!Q![+_!h!i+p#R#S+_#l#m+u~*|Q!Q![+S#R#S+S~+XQi~!Q![+S#R#S+S~+dSi~|}*y!Q![+_!h!i+p#R#S+_~+uOi~~+x]!Q![,q!c!d,q!d!e,q!e!f,q!f!g,q!g!h,q!h!i,q#T#U,q#U#V,q#V#W,q#W#X,q#X#Y,q#Y#Z,q~,v^i~!Q![,q!c!d,q!d!e,q!e!f,q!f!g,q!g!h,q!h!i,q#R#S,q#T#U,q#U#V,q#V#W,q#W#X,q#X#Y,q#Y#Z,q~-wO!R~~-|Qy~!^!_%g!_!`#p~.XP{~!_!`#p~.aQy~!_!`#p!`!a%g~.lWT~!Q![.g!c!}.g#R#S.g#T#o.g%w%x.g%|%}.g&`&a.g&f&g.g~/ZOo~~/`Oq~~/eO_~~/jQy~!_!`%o#p#q#p~/uO!`~",
  tokenizers: [0],
  topRules: {"Program":[0,3]},
  specialized: [{term: 5, get: (value) => spec_Ident[value] || -1}],
  tokenPrec: 756
});

const HPILanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ')', align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                'solange falls sonst überweise abbrechen weitermachen beantrage': tags.controlKeyword,
                'setze ändere funk auf von': tags.definitionKeyword,
                'ergibt': tags.typeOperator,
                als: tags.keyword,
                Bool: tags.bool,
                'BeantrageStmt/BeantrageFn/Ident': tags.namespace,
                'BeantrageStmt/BeantrageModule/Ident': tags.namespace,
                'VariableName/Ident': tags.variableName,
                'CallExpr/VariableName/Ident': tags.function(tags.variableName),
                CallExpr: tags.function(tags.propertyName),
                Type: tags.typeName,
                'FunctionDefinition/Ident': tags.labelName,
                'Parameters/Ident': tags.local(tags.variableName),
                LineComment: tags.lineComment,
                BlockComment: tags.blockComment,
                Number: tags.number,
                Char: tags.character,
                String: tags.string,
                '+ - "*" % "**" :': tags.arithmeticOperator,
                '|| &&': tags.logicOperator,
                '< <= > >= "!=" ==': tags.compareOperator,
                '=': tags.definitionOperator,
                '( ) { }': tags.bracket,
                '. , ; "/"': tags.separator,
                BuiltinFunc: tags.standard(tags.function(tags.variableName)),
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: '//' },
    },
});
const HPICompletion = HPILanguage.data.of({
    autocomplete: completeFromList([
        { label: 'funk', type: 'keyword' },
        { label: 'setze', type: 'keyword' },
        { label: 'überweise', type: 'keyword' },
        { label: 'abbrechen', type: 'keyword' },
        { label: 'weitermachen', type: 'keyword' },
        { label: 'falls', type: 'keyword' },
        { label: 'sont', type: 'keyword' },
        { label: 'solange', type: 'keyword' },
    ]),
});
function HPI() {
    return new LanguageSupport(HPILanguage, [HPICompletion]);
}

export { HPI, HPICompletion, HPILanguage };
